=== debian/changelog ===
qhull (2015.2-1) unstable; urgency=medium

  * New upstream release
  * Upstream fixes null stream tail chase (closes: #738339)
  * Swizzle doc pointer in man pages (closes: #784117)

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 15 Feb 2016 00:46:15 +0000

qhull (2012.1-5) unstable; urgency=medium

  * add symbols file
  * silence lintian binary-file-built-without-LFS-support

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 30 Apr 2014 13:13:14 +0100
